\section{Application to Pulp}
\label{sec:application-pulp}
To apply our network-coding approach to a concrete use case, we design
\approachName-Pulp, a protocol inspired by Pulp~\cite{felber_pulp:_2012}.  Pulp achieves
cost-effective dissemination by optimizing the combination of
push-based and pull-based gossip. In particular, nodes disseminate
each message through a push-phase with little redundancy due to a
fanout and a TTL configured to reach only a small portion of the
network.
%As they consider no redundancy, they use the following equation to configure their protocol: $c_{est} = \frac{\sum\limits_{i=0}^{ttl} k^i}{n}$
As the push-phase does not provide a complete dissemination, the
message will be retrieved by the rest of the network during the pull
phase.  To this end, each node periodically sends its list of missing
messages to a random node.  The target node answers with the first
message it knows.  To discover missing messages, nodes piggyback the
list of recently received messages on every packet exchange. To
improve reactivity and reduce delays, Pulp provides a pull-frequency
adaptation mechanism based on the node's estimations of the number of
missing messages and of the usefulness of its pull requests.



\input{fragments/algo-pulp-nc2}

% In the following, we show how our network-coding extensions to gossip
% dissemination (Algorithms~\ref{algo3}) easily lead to significant
% efficiency improvements on the already very efficient Pulp protocol.

% We build this protocol with the help of previously defined
% procedures in .


% As Pulp is composed of a push and a pull phase, we decided to extract
% the push and the pull phase of Pulp as generic protocols we convert to
% RLNC.  To make it generic and easily pluggable into Pulp, we piggyback
% on every exchanged messages a flexible structure named $headers$ which
% allows a point-to-point message exchange.


On top of the two previously defined algorithms~\ref{algo-push-nc}
and~\ref{algo-pull-nc}, we propose a push-pull algorithm inspired by
Pulp: Algorithm~\ref{algo7}.  First, we must convert  Pulp's
message-discovery mechanism which consists of exchanging recent
message histories via a trading window.  The trading window is generated
by the \textsc{GetHeaders} function, and is added to every
packet.  Upon reception, the trading window is retrieved and its
new identifiers are added to the $ids$ set.  The major difference
with Pulp is that we do not trade identifiers of delivered messages but
any identifiers we know  of, even if we compare both approaches in
Section~\ref{sec:evaluation}.

The adaptation mechanism is the second feature of Pulp, the pull
frequency is adapted according to the number of missing packets and
the usefulness of the pull requests. Our only modification is made on
how to compute the number of missing packets, as we retain the
number of needed independent linear combinations instead of the number
of missing messages. To do so, we compute the difference between the
number of message identifiers and the number of independent linear
combinations we have.

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: ../paper.tex
%%% End: 
